'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.updateConfig = updateConfig;
var config = {
  name: 'Lightrail',

  host: '0.0.0.0',

  port: 8000,

  timeout: 5000,

  payloadLimit: 1048576,

  stripUnknown: true,

  protect: true,

  log: { server: true, request: true, error: true },

  routeMap: { get: {}, post: {}, put: {}, patch: {}, delete: {} },

  isDev: function isDev() {
    return Boolean(String(process.env.NODE_ENV).match(/dev/i));
  }
};

function updateConfig() {
  var opts = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  config.name = opts.name || config.name;
  config.host = opts.host || config.host;
  config.port = parseInt(opts.port, 10) || config.port;
  config.timeout = parseInt(opts.timeout, 10) || config.timeout;
  config.payloadLimit = parseInt(opts.payloadLimit, 10) || config.payloadLimit;

  if (opts.stripUnknown !== undefined) {
    config.stripUnknown = opts.stripUnknown;
  }
  if (opts.protect !== undefined) {
    config.protect = opts.protect;
  }
  if (opts.log !== undefined) {
    config.log = opts.log !== false ? Object.assign({}, config.log, opts.log) : { server: false, request: false, error: false };
  }
}

exports.default = config;