'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

exports.cleanStackTrace = cleanStackTrace;

var _http = require('http');

var _http2 = _interopRequireDefault(_http);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Errors = function () {
  function Errors(statusCode, message) {
    (0, _classCallCheck3.default)(this, Errors);

    if (statusCode) {
      return this.get(statusCode, message);
    }
  }

  (0, _createClass3.default)(Errors, [{
    key: 'get',
    value: function get(statusCode, message) {
      var err = {
        statusCode: statusCode,
        error: _http2.default.STATUS_CODES[statusCode] || 'Unknown Error'
      };

      if (message) err.message = message;

      return err;
    }
  }, {
    key: 'badRequest',
    value: function badRequest(msg) {
      return this.get(400, msg);
    }
  }, {
    key: 'unauthorized',
    value: function unauthorized(msg) {
      return this.get(401, msg);
    }
  }, {
    key: 'paymentRequired',
    value: function paymentRequired(msg) {
      return this.get(402, msg);
    }
  }, {
    key: 'forbidden',
    value: function forbidden(msg) {
      return this.get(403, msg);
    }
  }, {
    key: 'notFound',
    value: function notFound(msg) {
      return this.get(404, msg);
    }
  }, {
    key: 'methodNotAllowed',
    value: function methodNotAllowed(msg) {
      return this.get(405, msg);
    }
  }, {
    key: 'notAcceptable',
    value: function notAcceptable(msg) {
      return this.get(406, msg);
    }
  }, {
    key: 'proxyAuthRequired',
    value: function proxyAuthRequired(msg) {
      return this.get(407, msg);
    }
  }, {
    key: 'requestTimeout',
    value: function requestTimeout(msg) {
      return this.get(408, msg);
    }
  }, {
    key: 'conflict',
    value: function conflict(msg) {
      return this.get(409, msg);
    }
  }, {
    key: 'gone',
    value: function gone(msg) {
      return this.get(410, msg);
    }
  }, {
    key: 'lengthRequired',
    value: function lengthRequired(msg) {
      return this.get(411, msg);
    }
  }, {
    key: 'preconditionFailed',
    value: function preconditionFailed(msg) {
      return this.get(412, msg);
    }
  }, {
    key: 'payloadTooLarge',
    value: function payloadTooLarge(msg) {
      return this.get(413, msg);
    }
  }, {
    key: 'uriTooLong',
    value: function uriTooLong(msg) {
      return this.get(414, msg);
    }
  }, {
    key: 'unsupportedMediaType',
    value: function unsupportedMediaType(msg) {
      return this.get(415, msg);
    }
  }, {
    key: 'rangeNotSatisfiable',
    value: function rangeNotSatisfiable(msg) {
      return this.get(416, msg);
    }
  }, {
    key: 'expectationFailed',
    value: function expectationFailed(msg) {
      return this.get(417, msg);
    }
  }, {
    key: 'unprocessableEntity',
    value: function unprocessableEntity(msg) {
      return this.get(422, msg);
    }
  }, {
    key: 'locked',
    value: function locked(msg) {
      return this.get(423, msg);
    }
  }, {
    key: 'failedDependency',
    value: function failedDependency(msg) {
      return this.get(424, msg);
    }
  }, {
    key: 'upgradeRequired',
    value: function upgradeRequired(msg) {
      return this.get(426, msg);
    }
  }, {
    key: 'preconditionRequired',
    value: function preconditionRequired(msg) {
      return this.get(428, msg);
    }
  }, {
    key: 'tooManyRequests',
    value: function tooManyRequests(msg) {
      return this.get(429, msg);
    }
  }, {
    key: 'headersTooLarge',
    value: function headersTooLarge(msg) {
      return this.get(431, msg);
    }
  }, {
    key: 'internal',
    value: function internal(msg) {
      return this.get(500, msg);
    }
  }, {
    key: 'notImplemented',
    value: function notImplemented(msg) {
      return this.get(501, msg);
    }
  }, {
    key: 'badGateway',
    value: function badGateway(msg) {
      return this.get(502, msg);
    }
  }, {
    key: 'serviceUnavailable',
    value: function serviceUnavailable(msg) {
      return this.get(503, msg);
    }
  }, {
    key: 'gatewayTimeout',
    value: function gatewayTimeout(msg) {
      return this.get(504, msg);
    }
  }, {
    key: 'httpVersionNotSupported',
    value: function httpVersionNotSupported(msg) {
      return this.get(505, msg);
    }
  }, {
    key: 'insufficientStorage',
    value: function insufficientStorage(msg) {
      return this.get(507, msg);
    }
  }, {
    key: 'loopDetected',
    value: function loopDetected(msg) {
      return this.get(508, msg);
    }
  }, {
    key: 'bandwidthLimitExceeded',
    value: function bandwidthLimitExceeded(msg) {
      return this.get(509, msg);
    }
  }, {
    key: 'notExtended',
    value: function notExtended(msg) {
      return this.get(510, msg);
    }
  }, {
    key: 'networkAuthRequired',
    value: function networkAuthRequired(msg) {
      return this.get(511, msg);
    }
  }]);
  return Errors;
}();

exports.default = Errors;
function cleanStackTrace(error) {
  if (!error.stack) return error;

  error.stack = error.stack.split('\n').filter(function (line) {
    return !line.match(/node_modules\//);
  }).join('\n');

  return error;
}