'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getIpAddress = getIpAddress;
exports.escapeRegex = escapeRegex;
function getIpAddress(request) {
  var remote = request.connection.remoteAddress || request.socket.remoteAddress;

  var forwarded = request.headers['x-forwarded-for'];
  if (!forwarded) return remote;

  return String(forwarded).split(',')[0].trim();
}

function escapeRegex(str) {
  return str.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, '\\$&');
}